Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.fasterxml.jackson.databind.deser
Class AbstractDeserializer

    java.lang.Object
      com.fasterxml.jackson.databind.JsonDeserializer<Object>
          com.fasterxml.jackson.databind.deser.AbstractDeserializer

    public class AbstractDeserializer

extends JsonDeserializer<Object>

Deserializer only used for abstract types used as placeholders during polymorphic type handling deserialization. If so, there is no real deserializer associated with nominal type, just `TypeDeserializer`; and any calls that do not pass such resolver will result in an error.

Author:
  tatu

Nested Class Summary

Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer
`JsonDeserializer.None`

Field Summary
`protected boolean` | `_acceptBoolean`
`protected boolean` | `_acceptDouble`
`protected boolean` | `_acceptInt`
`protected boolean` | `_acceptString`
`protected Map<String,SettableBeanProperty>` | `_backRefProperties`
`protected JavaType` | `_baseType`
`protected ObjectIdReader` | `_objectIdReader`

Constructor Summary
`AbstractDeserializer(BeanDeserializerBuilder builder, BeanDescription beanDesc, Map<String,SettableBeanProperty> backRefProps)`

Method Summary
`protected Object` | `_deserializeFromObjectId(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method called in cases where it looks like we got an Object Id to parse and use as a reference.
`protected Object` | `_deserializeIfNatural(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`Object` | `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`Object` | `deserializeWithType(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype.
`SettableBeanProperty` | `findBackReference(String logicalName)` Method called by `BeanDeserializer` to resolve back reference part of managed references.
`ObjectIdReader` | `getObjectIdReader()` Overridden to return true for those instances that are handling value for which Object Identity handling is enabled (either via value type or referring property).
`boolean` | `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer
`deserialize, getEmptyValue, getKnownPropertyNames, getNullValue, unwrappingDeserializer`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _baseType

    protected final JavaType _baseType

### _objectIdReader

    protected final ObjectIdReader _objectIdReader

### _backRefProperties

    protected final Map<String,SettableBeanProperty> _backRefProperties

### _acceptString

    protected final boolean _acceptString

### _acceptBoolean

    protected final boolean _acceptBoolean

### _acceptInt

    protected final boolean _acceptInt

### _acceptDouble

    protected final boolean _acceptDouble

Constructor Detail

### AbstractDeserializer

    public AbstractDeserializer(BeanDeserializerBuilder builder,
                                BeanDescription beanDesc,
                                Map<String,SettableBeanProperty> backRefProps)

Method Detail

### isCachable

    public boolean isCachable()

  Description copied from class: `JsonDeserializer`
  Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

  Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

  Default implementation returns false, to indicate that no caching is done.

  Overrides:
    `isCachable` in class `JsonDeserializer<Object>`

### getObjectIdReader

    public ObjectIdReader getObjectIdReader()

  Overridden to return true for those instances that are handling value for which Object Identity handling is enabled (either via value type or referring property).

  Overrides:
    `getObjectIdReader` in class `JsonDeserializer<Object>`
  Returns:
    ObjectIdReader used for resolving possible Object Identifier value, instead of full value serialization, if deserializer can do that; null if no Object Id is expected.

### findBackReference

    public SettableBeanProperty findBackReference(String logicalName)

  Method called by `BeanDeserializer` to resolve back reference part of managed references.

### deserializeWithType

    public Object deserializeWithType(com.fasterxml.jackson.core.JsonParser jp,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer)
                               throws IOException,
                                      com.fasterxml.jackson.core.JsonProcessingException

  Description copied from class: `JsonDeserializer`
  Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype. This can be due to annotation on type (or its supertype), or due to global settings without annotations.

  Default implementation may work for some types, but ideally subclasses should not rely on current default implementation. Implementation is mostly provided to avoid compilation errors with older code.

  Overrides:
    `deserializeWithType` in class `JsonDeserializer<Object>`
    `typeDeserializer` - Deserializer to use for handling type information
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserialize

    public Object deserialize(com.fasterxml.jackson.core.JsonParser jp,
                              DeserializationContext ctxt)
                       throws IOException,
                              com.fasterxml.jackson.core.JsonProcessingException

  Description copied from class: `JsonDeserializer`
  Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

  Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

  Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

  Specified by:
    `deserialize` in class `JsonDeserializer<Object>`
  Parameters:
    `jp` - Parsed used for reading JSON content
    `ctxt` - Context that can be used to access information about this deserialization activity.
  Returns:
    Deserializer value
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### _deserializeIfNatural

    protected Object _deserializeIfNatural(com.fasterxml.jackson.core.JsonParser jp,
                                           DeserializationContext ctxt)
                                    throws IOException,
                                           com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### _deserializeFromObjectId

    protected Object _deserializeFromObjectId(com.fasterxml.jackson.core.JsonParser jp,
                                              DeserializationContext ctxt)
                                       throws IOException,
                                              com.fasterxml.jackson.core.JsonProcessingException

  Method called in cases where it looks like we got an Object Id to parse and use as a reference.

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2012 fasterxml.com. All Rights Reserved.